global currentSite, siteList, log, ISDNmode

on find
  if not length(field "NetSearchEnterField") then
    exit
  end if
  nonsenseConnections(2)
  go("SearchResult")
  shuffleHits()
  add(log, "SearchResult")
end

on link selectedLineNo
  set selectedLineText to line selectedLineNo of field "mainDisplayField"
  if selectedLineText contains "//www" then
    nonsenseConnections(random(5) + 2)
    set location to selectAlocation(selectedLineText)
    if length(location) then
      openLocationRandom()
    else
      notFound()
    end if
  end if
end

on notFound
  go("NotFound")
end

on shuffleHits
  cursor(4)
  set the itemDelimiter to "•"
  set numberOfEntries to the number of items in field "HitTexts"
  set remainingList to []
  repeat with i = 1 to numberOfEntries
    add(remainingList, i)
  end repeat
  set the text of member "ResultField" to EMPTY
  set the text of member "mainDisplayField" to EMPTY
  set desiredNumberOfHits to random(40) + 10
  set the text of member "ResultField" to string(random(10000) + desiredNumberOfHits) & " entries matching " & QUOTE & field "NetSearchEnterField" & QUOTE & " found."
  repeat with i = 1 to desiredNumberOfHits
    set selectedItemIndexInRemainingList to random(count(remainingList))
    set selectedItemIndex to getAt(remainingList, selectedItemIndexInRemainingList)
    deleteAt(remainingList, selectedItemIndexInRemainingList)
    set the text of member "mainDisplayField" to the text of member "mainDisplayField" & item 1 + selectedItemIndex of field "HitTexts"
  end repeat
  cursor(-1)
end

on nonsenseText text, time
  set the text of field "messageField" to text
  updateStage()
  set stopTime to the ticks + time
  repeat while the ticks < stopTime
  end repeat
end

on nonsenseConnections seconds
  set ISDNmode to 1
  set seconds to seconds * (3 * not ISDNmode)
  nonsenseText("Connect: Locking up host:HTTP://WWW.kan.ikke.lese.denne.teksten.no.no.no", 20)
  nonsenseText("Connect: Contacting host:HTTP://WWW.vent.litt.jeg.skal.bare.hente.brillene.mine.no.no.no", 20)
  nonsenseText("Connect: Transferring:HTTP://WWW.vent.jeg.rekker.ikke.å.lese.denne.viktige.informasjonen.no.no.no", 20)
  set timeToStop to the ticks + (60 * seconds)
  repeat while the ticks < timeToStop
    if random(1000) < 2 then
      set the text of field "messageField" to "Vet du hvordan man holder en tufs i åndeløs spenning? "
      updateStage()
      repeat with i = 1 to 100000
      end repeat
    end if
    set n to field "nonsenseConnectionTexts"
    set the text of field "messageField" to line random(the number of lines in n) of n
    updateStage()
  end repeat
  set the text of field "messageField" to "Document: Done"
end

on selectAlocation
  return EMPTY
end

on openLocationRandom
  put " openLocationRandom", currentSite, the frameLabel
  if the frameLabel = currentSite then
    exit
  end if
  set currentSite to getAt(siteList, random(count(siteList)))
  if the labelList contains currentSite then
    go(currentSite)
    add(log, currentSite)
  end if
end

on bill
  if the frameLabel = currentSite then
    exit
  end if
  nonsenseConnections(1)
  add(log, "Bill")
  go("Bill")
end

on BillyText destination
  if the frameLabel = destination then
    exit
  end if
  if not (the labelList) contains destination then
    exit
  end if
  nonsenseConnections(1)
  add(log, destination)
  go(destination)
end

on back
  if the frameLabel = "MainLoop" then
    exit
  end if
  nonsenseConnections(1)
  if count(log) < 2 then
    go("MainLoop")
  else
    deleteAt(log, count(log))
    go(getAt(log, count(log)))
  end if
end

on moveSprite spriteNo
  set the puppet of sprite spriteNo to 1
  set offset to the loc of sprite spriteNo - point(the mouseH, the mouseV)
  repeat while the mouseDown
    set the loc of sprite spriteNo to point(the mouseH, the mouseV) + offset
    updateStage()
  end repeat
  repeat while the locV of sprite spriteNo < 500
    set the locV of sprite spriteNo to the locV of sprite spriteNo + 20
    updateStage()
  end repeat
end
